local fRaid = {}
local fGear = {}
local fQuest = {}
local fParty = {}
local fSpells = {}
local fPlayer = {}
local fCombat = {}
local fTarget = {}
local fDebuff = {}
local fThreat = {}
local fOption = {}

local playStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local poneStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local ptwoStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local pthrStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local pfouStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local pfivStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local psixStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local psevStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local peigStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
local pninStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}

local ShowText = {"","","",""}
local charStatBase = {"","","","","",""}
local pgroStatBase = {}
local pAttribArea, pAttribStat = "Name", ""
local qText, xText, eText = " ", " ", " "
local pQuick = 0
local sTarget = 0

local function GetPartyStat(statID, viewID)
	local pStats = { UnitHealth(statID), UnitPower(statID), UnitPowerMax(statID), UnitHealthMax(statID) }
	if(pStats[3] > 0) then
		if(pStats[4] > 0) then
			viewID:SetText(format("%.0f", ((pStats[1] / pStats[4]) * 100)) .. "\n" .. format("%.0f", ((pStats[2] / pStats[3]) * 100)))
		end
	end
end

local function GetQuestPosition()
	local pMap = C_Map.GetBestMapForUnit("player")
	if(pMap ~= nil) then
		local pX = C_Map.GetPlayerMapPosition(pMap, "player")
		if(pX ~= nil) then
			return "X: " .. format("%.1f",pX.x*100) .. " Y: " .. format("%.1f",pX.y*100)
		end
	end
	return "X: 0, Y: 0"
end

local function GetPlayerDist(pID)
	local fCheck = CheckInteractDistance(pID, 4)
	local mCheck = CheckInteractDistance(pID, 2)
	local nCheck = CheckInteractDistance(pID, 3)
	if(pID == "player") then return GetQuestPosition() end
	if(nCheck == true) then return "< 8 yds" end
	if(mCheck == true) then return "< 10 yds" end
	if(fCheck == true) then return "8 yds - 28 yds" end
	return "28 - ? yds"
end

local function EmptySlots()
	local i,j = 0,0
	repeat
		local eSlots, eType = GetContainerNumFreeSlots(i)
		if(eSlots ~= nil) then
			if(eType == 0) then j = j + eSlots; end
		end
		i = i + 1
	until(i > 4)
	return j
end

local function AmmoLeft()
	local m = GetInventorySlotInfo("AmmoSlot")
	local n = GetInventoryItemCount("player", m)
	return n	
end

local function GetPlayerStat(partyID, TitleID, BannerID)
	local pName = UnitName(partyID)
	local pUsedTarget, pUsedRealm = UnitName("playertargettarget")
	local pTargetName = ""
	if(pUsedTarget ~= nil) then pTargetName = "Is targeting " .. pUsedTarget end
	if(partyID ~= "player") then pSlots = "" end
	if(pName ~= nil) then
		local pHealth = UnitHealth(partyID)
		local pMana = UnitPower(partyID)
		local pRange = GetPlayerDist(partyID)
		local pMaxPer = (pHealth / UnitHealthMax(partyID)) * 100
		local pMaxMana = (pMana / UnitPowerMax(partyID)) * 100
		local pAmmo = AmmoLeft()
		local pText = pName
		local pvText = pHealth .. "\n" .. pMana
		if(partyID == "player") then
			if(pAmmo ~= nil) then
				if(pAmmo > 1) then pText = pText .. " " .. pAmmo  .. " rounds" end
			end
		end
		pText = pText .. "\n" .. format("%.0f%%", pMaxPer)
		if(tostring(pMaxMana) ~= "nan") then pText = pText .. " " .. format("%.0f%%", pMaxMana) end
		pText = pText .. "\n"
		if(pRange ~= nil) then pText = pText .. " " .. pRange end
		if(partyID == "player") then
			local aHealth = UnitHealth(partyID .. "pet")
			local aMana = UnitPower(partyID .. "pet")
			pText = pText .. " S: " .. EmptySlots()
			if(aHealth ~= nil) then
				if(aHealth > 0) then
					pvText = pvText .. "\n" .. aHealth .. "\n" .. aMana
					fPlayer[4]:SetWidth((UnitHealth("playerpet")/UnitHealthMax("playerpet")) * 400)
					fPlayer[5]:SetWidth((UnitPower("playerpet")/UnitPowerMax("playerpet")) * 400)
				end
			end
			pText = pText .. "\n" .. pTargetName
			fPlayer[2]:SetWidth((UnitHealth("player")/UnitHealthMax("player")) * 400)
			fPlayer[3]:SetWidth((UnitPower("player")/UnitPowerMax("player")) * 400)
		end
		if(partyID ~= "player") then
			fTarget[2]:SetWidth((UnitHealth(partyID)/UnitHealthMax(partyID)) * 400)
			fTarget[3]:SetWidth((UnitPower(partyID)/UnitPowerMax(partyID)) * 400)
		end
		TitleID:SetText(pText)
		BannerID:SetText(pvText)
	end
end

local function GetAllTargets(numUsed)
	local statusParty = ""
	if(numUsed < 6) then
		for t=1,4 do
			local partyName, partyRealm = UnitName("party" .. t)
			local partyTarget, TargetRealm = UnitName("party" .. t .. "target")
			local ptTarget, ptRealm = UnitName("party" .. t .. "targettarget")
			local atDist = GetPlayerDist("party" .. t .. "target")
			local pFound = 0
			local hUsed = (UnitHealth("party" .. t .. "target") / UnitHealthMax("party" .. t .. "target")) * 100
			if(partyName ~= nil) then
				if(partyTarget ~= nil) then 
					if(ptTarget ~= nil) then
						statusParty = statusParty .. "\n" .. partyName .. " target " .. partyTarget .. " (" .. format("%.0f%%", hUsed) .. ") is targeting " .. ptTarget .. " approx. " .. atDist
						pFound = 1
					end
				end
			end
			if(pFound == 0) then statusParty = statusParty .. "\n" .. "P" .. (t + 1) .. " has no targets." end
		end
	end
	if(numUsed > 5) then
		for t=1,9 do
			local partyName, partyRealm = UnitName("raid" .. t)
			local partyTarget, TargetRealm = UnitName("raid" .. t .. "target")
			local ptTarget, ptRealm = UnitName("raid" .. t .. "targettarget")
			local atDist = GetPlayerDist("party" .. t .. "target")
			local pFound = 0
			local hUsed = (UnitHealth("party" .. t .. "target") / UnitHealthMax("party" .. t .. "target")) * 100
			if(partyName ~= nil) then
				if(partyTarget ~= nil) then 
					if(ptTarget ~= nil) then
						statusParty = statusParty .. "\n" .. partyName .. " target " .. partyTarget .. " (" .. format("%.0f%%", hUsed) .. ") is targeting " .. ptTarget .. " approx. " .. atDist
						pFound = 1
					end
				end
			end
			if(pFound == 0) then statusParty = statusParty .. "\n" .. "R" .. (t + 1) .. " has no targets." end
		end
	end
	fThreat[2]:SetText(statusParty)
end

local function UpdatePartyStats()
	local pGroupNum = GetNumGroupMembers()
	GetPlayerStat("player",fPlayer[6],fPlayer[7])
	GetPlayerStat("target",fTarget[6],fTarget[7])
	GetAllTargets(pGroupNum)
	for r=11,50 do
		fRaid[r]:SetText(" ")
	end
	if(pGroupNum < 6) then
		GetPartyStat("player",fRaid[11])
		if(pGroupNum > 1) then GetPartyStat("party1",fRaid[12]); GetPartyStat("party1pet",fRaid[22]); end
		if(pGroupNum > 2) then GetPartyStat("party2",fRaid[13]); GetPartyStat("party2pet",fRaid[23]); end
		if(pGroupNum > 3) then GetPartyStat("party3",fRaid[14]); GetPartyStat("party3pet",fRaid[24]); end
		if(pGroupNum > 4) then GetPartyStat("party4",fRaid[15]); GetPartyStat("party4pet",fRaid[25]); end
	end
	if(pGroupNum > 5) then
		if(pGroupNum > 0) then GetPartyStat("raid1",fRaid[11]); GetPartyStat("raid1pet",fRaid[31]); end
		if(pGroupNum > 1) then GetPartyStat("raid2",fRaid[12]); GetPartyStat("raid2pet",fRaid[32]); end
		if(pGroupNum > 2) then GetPartyStat("raid3",fRaid[13]); GetPartyStat("raid3pet",fRaid[33]); end
		if(pGroupNum > 3) then GetPartyStat("raid4",fRaid[14]); GetPartyStat("raid4pet",fRaid[34]); end
		if(pGroupNum > 4) then GetPartyStat("raid5",fRaid[15]); GetPartyStat("raid5pet",fRaid[35]); end
		if(pGroupNum > 5) then GetPartyStat("raid6",fRaid[16]); GetPartyStat("raid6pet",fRaid[36]); end
		if(pGroupNum > 6) then GetPartyStat("raid7",fRaid[17]); GetPartyStat("raid7pet",fRaid[37]); end
		if(pGroupNum > 7) then GetPartyStat("raid8",fRaid[18]); GetPartyStat("raid8pet",fRaid[38]); end
		if(pGroupNum > 8) then GetPartyStat("raid9",fRaid[19]); GetPartyStat("raid9pet",fRaid[39]); end
		if(pGroupNum > 9) then GetPartyStat("raid10",fRaid[20]); GetPartyStat("raid10pet",fRaid[40]); end
		if(pGroupNum > 10) then GetPartyStat("raid11",fRaid[21]); GetPartyStat("raid11pet",fRaid[41]); end
		if(pGroupNum > 11) then GetPartyStat("raid12",fRaid[22]); GetPartyStat("raid12pet",fRaid[42]); end
		if(pGroupNum > 12) then GetPartyStat("raid13",fRaid[23]); GetPartyStat("raid13pet",fRaid[43]); end
		if(pGroupNum > 13) then GetPartyStat("raid14",fRaid[24]); GetPartyStat("raid14pet",fRaid[44]); end
		if(pGroupNum > 14) then GetPartyStat("raid15",fRaid[25]); GetPartyStat("raid15pet",fRaid[45]); end
		if(pGroupNum > 15) then GetPartyStat("raid16",fRaid[26]); GetPartyStat("raid16pet",fRaid[46]); end
		if(pGroupNum > 16) then GetPartyStat("raid17",fRaid[27]); GetPartyStat("raid17pet",fRaid[47]); end
		if(pGroupNum > 17) then GetPartyStat("raid18",fRaid[28]); GetPartyStat("raid18pet",fRaid[48]); end
		if(pGroupNum > 18) then GetPartyStat("raid19",fRaid[29]); GetPartyStat("raid19pet",fRaid[49]); end
		if(pGroupNum > 19) then GetPartyStat("raid20",fRaid[30]); GetPartyStat("raid19pet",fRaid[50]); end
	end
end

local function UpdateSpellCast(tID, sID, uID, wID, yID, bID)
	bID:SetAttribute("type1", "macro")
	bID:SetAttribute("macrotext1", "/target " .. tID .. "\n/cast " .. sID)
	bID:SetAttribute("type2", "macro")
	bID:SetAttribute("macrotext2", "/target " .. tID .. "\n/cast " .. uID)
	bID:SetAttribute("shift-type1", "macro")
	bID:SetAttribute("shift-macrotext1", "/target " .. tID .. "\n/cast " .. yID)
	bID:SetAttribute("shift-type2", "macro")
	bID:SetAttribute("shift-macrotext2", "/target " .. tID .. "\n/cast " .. wID)
end

local function UpdateSpellIcon(spID, bID)
	local iArea = bID:CreateTexture(nil,"OVERLAY")
	local _, _, iSpell, _, _, _, _ = GetSpellInfo(spID)
	iArea:SetTexture(iSpell)
	iArea:SetPoint("CENTER")
	iArea:SetSize(32,32)
end

local function UpdateClassSpells()
	local _, _, pclassID = UnitClass("player")
	local spellStak = { "Attack","Attack","Attack","Attack" }
	if(pclassID == 1) then spellStak = { "Bloodrage", "Battle Shout", "Demoralizing Shout","Sunder Armor" } end
	if(pclassID == 2) then spellStak = { "Holy Light", "Flash of Light", "Blessing of Might", "Blessing of Wisdom", "Holy Light" } end
	if(pclassID == 3) then spellStak = { "Hunter's Mark", "Aspect of the Monkey", "Aspect of the Hawk", "Concussive Shot" } end
	if(pclassID == 4) then spellStak = { "Stealth", "Evasion", "Sprint", "Kick" } end
	if(pclassID == 5) then spellStak = { "Lesser Heal", "Renew", "Power Word: Shield", "Flash Heal" } end
	if(pclassID == 7) then spellStak = { "Stoneskin Totem", "Earthbind Totem", "Stoneclaw Totem", "Searing Totem" } end
	if(pclassID == 8) then spellStak = { "Arcane Intellect", "Frost Armor", "Conjore Water", "Conjore Food" } end
	if(pclassID == 9) then spellStak = { "Life Tap", "Demon Skin", "Create Healthstone", "Create Soulstone" } end
	if(pclassID == 11) then spellStak = { "Healing Touch", "Regrowth", "Mark of the Wild", "Moonfire" } end

	if(UnitAffectingCombat("player") == false) then
		local gSpellUsed = GetNumGroupMembers()
		UpdateSpellCast("player",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[11])
		if(gSpellUsed > 5) then
			UpdateSpellCast("player",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fPlayer[1])
			UpdateSpellCast("raid1",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[11])
			UpdateSpellCast("raid2",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[12])
			UpdateSpellCast("raid3",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[13])
			UpdateSpellCast("raid4",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[14])
			UpdateSpellCast("raid5",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[15])
			UpdateSpellCast("raid6",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[16])
			UpdateSpellCast("raid7",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[17])
			UpdateSpellCast("raid8",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[18])
			UpdateSpellCast("raid9",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[19])
			UpdateSpellCast("raid10",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[20])
			UpdateSpellCast("raid11",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[21])
			UpdateSpellCast("raid12",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[22])
			UpdateSpellCast("raid13",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[23])
			UpdateSpellCast("raid14",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[24])
			UpdateSpellCast("raid15",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[25])
			UpdateSpellCast("raid16",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[26])
			UpdateSpellCast("raid17",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[27])
			UpdateSpellCast("raid18",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[28])
			UpdateSpellCast("raid19",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[29])
			UpdateSpellCast("raid20",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[30])
			UpdateSpellCast("raid1pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[31])
			UpdateSpellCast("raid2pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[32])
			UpdateSpellCast("raid3pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[33])
			UpdateSpellCast("raid4pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[34])
			UpdateSpellCast("raid5pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[35])
			UpdateSpellCast("raid6pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[36])
			UpdateSpellCast("raid7pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[37])
			UpdateSpellCast("raid8pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[38])
			UpdateSpellCast("raid9pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[39])
			UpdateSpellCast("raid10pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[40])
			UpdateSpellCast("raid11pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[41])
			UpdateSpellCast("raid12pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[42])
			UpdateSpellCast("raid13pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[43])
			UpdateSpellCast("raid14pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[44])
			UpdateSpellCast("raid15pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[45])
			UpdateSpellCast("raid16pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[46])
			UpdateSpellCast("raid17pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[47])
			UpdateSpellCast("raid18pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[48])
			UpdateSpellCast("raid19pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[49])
			UpdateSpellCast("raid20pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[50])
		end
		if(gSpellUsed < 6) then
			UpdateSpellCast("player",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fPlayer[1])
			UpdateSpellCast("player",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[11])
			UpdateSpellCast("party1",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[12])
			UpdateSpellCast("party2",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[13])
			UpdateSpellCast("party3",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[14])
			UpdateSpellCast("party4",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[15])
			UpdateSpellCast("playerpet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[16])
			UpdateSpellCast("party1pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[17])
			UpdateSpellCast("party2pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[18])
			UpdateSpellCast("party3pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[19])
			UpdateSpellCast("party4pet",spellStak[1],spellStak[2],spellStak[3],spellStak[4],fRaid[20])
		end
		fRaid[10]:SetAttribute("macrotext1","/targetfriend")
		fRaid[10]:SetAttribute("macrotext2","/cast " .. spellStak[4])
		fRaid[10]:SetAttribute("shift-macrotext1","/cast " .. spellStak[1])
		fRaid[10]:SetAttribute("shift-macrotext2","/cast " .. spellStak[2])
		UpdateSpellIcon(spellStak[4], fRaid[10])
	end
end

local function UpdateSpellSet(ssa, ssb)
	local ssi = ssa:CreateTexture(nil,"OVERLAY")
	local _, _, iSpell, _, _, _, _ = GetSpellInfo(ssb)
	ssi:SetTexture(iSpell)
	ssi:SetPoint("CENTER")
	ssi:SetSize(32,32)
	ssa:SetAttribute("type", "spell")
	ssa:SetAttribute("spell", ssb)
end

local function SetSpells()
	local sUsed = ""
	
	if(sTarget == 1) then UpdateSpellSet(spellBase[4], sUsed) end
	if(sTarget == 2) then UpdateSpellSet(spellBase[5], sUsed) end
	if(sTarget == 3) then UpdateSpellSet(spellBase[6], sUsed) end
	if(sTarget == 4) then UpdateSpellSet(spellBase[7], sUsed) end
	if(sTarget == 5) then UpdateSpellSet(spellBase[8], sUsed) end
	if(sTarget == 6) then UpdateSpellSet(spellBase[9], sUsed) end
	if(sTarget == 7) then UpdateSpellSet(spellBase[10], sUsed) end
	if(sTarget == 8) then UpdateSpellSet(spellBase[11], sUsed) end
	if(sTarget == 9) then UpdateSpellSet(spellBase[12], sUsed) end
end

local function VendorGray()
	local i,h,j,xSold,xFree,gqItem = 0,0,0,0,0,0
	repeat
		local gSlots = GetContainerNumSlots(i)
		if(gSlots ~= nil) then
			j = 1
			repeat
				local gItemLink = GetContainerItemLink(i, j)
				if(gItemLink ~= nil) then
					local _,_,gQuality = GetItemInfo(gItemLink)
					if(gQuality ~= nil) then
						if(gQuality == 0) then UseContainerItem(i,j) ; xSold = xSold + 1 end
					end
				end
				j = j + 1
			until(j > gSlots)
		end
		i = i + 1
	until(i > 4)
	DEFAULT_CHAT_FRAME:AddMessage("Sold " .. xSold .. " gray items.")
end

local function playCombat(cmShow)
	local comavg = { (cmShow[8] + cmShow[14]), 0, 0, (cmShow[9] + cmShow[15]) }

	if(cmShow[16] > 0) then comavg[2] = cmShow[17] / cmShow[16] end
	if(cmShow[8] > 0) then
		if(cmShow[14] > 0) then
			comavg[3] = (cmShow[9] + cmShow[15]) / (cmShow[8] + cmShow[14])
		end
	end

	ShowText[1] = ShowText[1] .. "\nMissed\nSwing\nSpell\nRange\nAttacks\n\nHealed\nHealing\nHeals\n\nDamage"
	ShowText[2] = ShowText[2] .. format("%8s", "Hits")
	ShowText[3] = ShowText[3] .. format("%8s", "Average")
	ShowText[4] = ShowText[4] .. format("%8s", "Total")

	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[7])
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[1])
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[3])
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[5])
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[16])

	ShowText[2] = ShowText[2] .. "\n"
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[8])
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[14])
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", comavg[1])

	ShowText[2] = ShowText[2] .. "\n"
	ShowText[2] = ShowText[2] .. "\n" .. format("%8d", cmShow[12])

	ShowText[3] = ShowText[3] .. "\n"
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", cmShow[19])
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", cmShow[20])
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", cmShow[21])
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", comavg[2])

	ShowText[3] = ShowText[3] .. "\n"
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", cmShow[22])
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", cmShow[24])
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", comavg[3])

	ShowText[3] = ShowText[3] .. "\n"
	ShowText[3] = ShowText[3] .. "\n" .. format("%8d", cmShow[23])

	ShowText[4] = ShowText[4] .. "\n"
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[2])
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[4])
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[6])
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[17])

	ShowText[4] = ShowText[4] .. "\n"
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[9])
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[15])
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", comavg[4])

	ShowText[4] = ShowText[4] .. "\n"
	ShowText[4] = ShowText[4] .. "\n" .. format("%10d", cmShow[13])
end

local function playQuick(cmShow)
	local quiavg = { cmShow[8], 0, 0, cmShow[9] }

	if(cmShow[16] > 0) then quiavg[2] = cmShow[17] / cmShow[16] end
	if(cmShow[8] > 0) then
		quiavg[3] = cmShow[9] / cmShow[8]
	end

	ShowText[1] = ShowText[1] .. "\nAttacks\nHeals\nDamage"
	ShowText[2] = ShowText[2] .. format("%8s", "Hits")
	ShowText[3] = ShowText[3] .. format("%8s", "Average")
	ShowText[4] = ShowText[4] .. format("%8s", "Total")

	ShowText[2] = ShowText[2] .. "\n|cFFFFFFFF" .. format("%8d", cmShow[16]) .. "|r"
	ShowText[2] = ShowText[2] .. "\n|cFF00FF00" .. format("%8d", quiavg[1]) .. "|r"
	ShowText[2] = ShowText[2] .. "\n|cFFFF0000" .. format("%8d", cmShow[12]) .. "|r"

	ShowText[3] = ShowText[3] .. "\n|cFFFFFFFF" .. format("%8d", quiavg[2]) .. "|r"
	ShowText[3] = ShowText[3] .. "\n|cFF00FF00" .. format("%8d", quiavg[3]) .. "|r"
	ShowText[3] = ShowText[3] .. "\n|cFFFF0000" .. format("%8d", cmShow[23]) .. "|r"

	ShowText[4] = ShowText[4] .. "\n|cFFFFFFFF" .. format("%10d", cmShow[17]) .. "|r"
	ShowText[4] = ShowText[4] .. "\n|cFF00FF00" .. format("%10d", quiavg[4]) .. "|r"
	ShowText[4] = ShowText[4] .. "\n|cFFFF0000" .. format("%10d", cmShow[13]) .. "|r"
end

local function UpdateStatBase(sbTar, sbUsed, ...)
	local _, peventtype, _, psourceGUID, _, _, _, pdestGUID, _, _, _ = ...
	
	if(psourceGUID == sbTar) then
		if(peventtype == "SWING_DAMAGE") then
			local pamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			sbUsed[1] = sbUsed[1] + 1 ; sbUsed[2] = sbUsed[2] + pamount
		end
		if(peventtype == "SPELL_DAMAGE") then
			local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			sbUsed[3] = sbUsed[3] + 1 ; sbUsed[4] = sbUsed[4] + pspellamount
		end
		if(peventtype == "SPELL_PERIODIC_DAMAGE") then
			local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			sbUsed[3] = sbUsed[3] + 1 ; sbUsed[4] = sbUsed[4] + pspellamount
		end
		if(peventtype == "RANGE_DAMAGE") then
			local _, _, _, prangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			sbUsed[5] = sbUsed[5] + 1 ; sbUsed[6] = sbUsed[6] + prangeamount
		end

		if(peventtype == "SWING_MISSED") then sbUsed[7] = sbUsed[7] + 1 end
		if(peventtype == "SPELL_MISSED") then sbUsed[7] = sbUsed[7] + 1 end 
		if(peventtype == "RANGE_MISSED") then sbUsed[7] = sbUsed[7] + 1 end

		if(pdestGUID == sbTar) then
			if(peventtype == "SPELL_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[8] = sbUsed[8] + 1 ; sbUsed[9] = sbUsed[9] + pspellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[8] = sbUsed[8] + 1 ; sbUsed[9] = sbUsed[9] + pspellamount
			end
		end
		if(pdestGUID ~= sbTar) then
			if(peventtype == "SPELL_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[8] = sbUsed[8] + 1 ; sbUsed[9] = sbUsed[9] + pspellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[8] = sbUsed[8] + 1 ; sbUsed[9] = sbUsed[9] + pspellamount
			end
		end
	end
	if(psourceGUID ~= sbTar) then
		if(pdestGUID == sbTar) then
			if(peventtype == "SWING_DAMAGE") then
				local pdamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[12] = sbUsed[12] + 1 ; sbUsed[13] = sbUsed[13] + pdamount
			end
			if(peventtype == "SPELL_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[12] = sbUsed[12] + 1 ; sbUsed[13] = sbUsed[13] + spellamount
			end
			if(peventtype == "SPELL_PERIODIC_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[12] = sbUsed[12] + 1 ; sbUsed[13] = sbUsed[13] + spellamount
			end
			if(peventtype == "RANGE_DAMAGE") then
				local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[12] = sbUsed[12] + 1 ; sbUsed[13] = sbUsed[13] + rangeamount
			end

			if(peventtype == "SWING_MISSED") then sbUsed[12] = sbUsed[12] + 1 end
			if(peventtype == "SPELL_MISSED") then sbUsed[12] = sbUsed[12] + 1 end
			if(peventtype == "RANGE_MISSED") then sbUsed[12] = sbUsed[12] + 1 end

			if(peventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[14] = sbUsed[14] + 1 ; sbUsed[15] = sbUsed[15] + spellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sbUsed[14] = sbUsed[14] + 1 ; sbUsed[15] = sbUsed[15] + spellamount
			end
		end
	end

	sbUsed[16] = (sbUsed[1] + sbUsed[3] + sbUsed[5] + sbUsed[7])
	sbUsed[17] = (sbUsed[2] + sbUsed[4] + sbUsed[6])

	if(sbUsed[1] > 0) then sbUsed[19] = (sbUsed[2] / sbUsed[1]) end
	if(sbUsed[3] > 0) then sbUsed[20] = (sbUsed[4] / sbUsed[3]) end
	if(sbUsed[5] > 0) then sbUsed[21] = (sbUsed[6] / sbUsed[5]) end
	if(sbUsed[8] > 0) then sbUsed[22] = (sbUsed[9] / sbUsed[8]) end
	if(sbUsed[12] > 0) then sbUsed[23] = (sbUsed[13] / sbUsed[12]) end
	if(sbUsed[14] > 0) then sbUsed[24] = (sbUsed[15] / sbUsed[14]) end
end

local function SendStatus(self, ...)
	local statGUID = { UnitGUID("player"), UnitGUID("party1"), UnitGUID("party2"), UnitGUID("party3"), UnitGUID("party4") }
	local raidGUID = { UnitGUID("raid1"), UnitGUID("raid2"), UnitGUID("raid3"), UnitGUID("raid4"), UnitGUID("raid5"), UnitGUID("raid6"), UnitGUID("raid7"), UnitGUID("raid8"), UnitGUID("raid9") }
	local pgNum = GetNumGroupMembers()
	
	UpdateStatBase(statGUID[1], playStatBase, ...)
	if(pgNum < 6) then
		if(statGUID[2] ~= nil) then UpdateStatBase(statGUID[2], poneStatBase, ...) end
		if(statGUID[3] ~= nil) then UpdateStatBase(statGUID[3], ptwoStatBase, ...) end
		if(statGUID[4] ~= nil) then UpdateStatBase(statGUID[4], pthrStatBase, ...) end
		if(statGUID[5] ~= nil) then UpdateStatBase(statGUID[5], pfouStatBase, ...) end
	end
	if(pgNum > 5) then
		if(raidGUID[1] ~= nil) then UpdateStatBase(raidGUID[1], poneStatBase, ...) end
		if(raidGUID[2] ~= nil) then UpdateStatBase(raidGUID[2], ptwoStatBase, ...) end
		if(raidGUID[3] ~= nil) then UpdateStatBase(raidGUID[3], pthrStatBase, ...) end
		if(raidGUID[4] ~= nil) then UpdateStatBase(raidGUID[4], pfouStatBase, ...) end
		if(raidGUID[5] ~= nil) then UpdateStatBase(raidGUID[5], pfivStatBase, ...) end
		if(raidGUID[6] ~= nil) then UpdateStatBase(raidGUID[6], psixStatBase, ...) end
		if(raidGUID[7] ~= nil) then UpdateStatBase(raidGUID[7], psevStatBase, ...) end
		if(raidGUID[8] ~= nil) then UpdateStatBase(raidGUID[8], peigStatBase, ...) end
		if(raidGUID[9] ~= nil) then UpdateStatBase(raidGUID[9], pninStatBase, ...) end
	end
end

local function UpdateSlotGear(gearUpdate)
	local pitemLink = GetInventoryItemLink("player", GetInventorySlotInfo(gearUpdate))
	if(pitemLink ~= nil) then 
		local wName, _, wRare, wLvl = GetItemInfo(pitemLink) ;
		charStatBase[1] = tostring(tonumber(charStatBase[1]) + 1)
		if(wLvl ~= nil) then charStatBase[2] = tostring(tonumber(charStatBase[2]) + wLvl) end 
	end
end

local function UpdateGear()
	charStatBase[1] = "0"
	charStatBase[2] = "0"
	UpdateSlotGear("MainHandSlot")
	UpdateSlotGear("SecondaryHandSlot")
	UpdateSlotGear("HeadSlot")
	UpdateSlotGear("NeckSlot")
	UpdateSlotGear("ShoulderSlot")
	UpdateSlotGear("BackSlot")
	UpdateSlotGear("ChestSlot")
	UpdateSlotGear("WristSlot")
	UpdateSlotGear("HandsSlot")
	UpdateSlotGear("WaistSlot")
	UpdateSlotGear("LegsSlot")
	UpdateSlotGear("FeetSlot")
	UpdateSlotGear("Finger0Slot")
	UpdateSlotGear("Finger1Slot")
	UpdateSlotGear("Trinket0Slot")
	UpdateSlotGear("Trinket1Slot")
	UpdateSlotGear("AmmoSlot")
	UpdateSlotGear("RangedSlot")
end

local function UpdateTextStat(saLeft, saRight)
	local upLeft, upRight = "", ""
	if(saLeft ~= nil) then upLeft = saLeft end
	if(saRight ~= nil) then upRight = saRight end
	pAttribArea = pAttribArea .. "\n" .. upLeft
	pAttribStat = pAttribStat .. "\n" .. upRight
end

local function GetCombatHit(hType)
	local crActual = GetCombatRating(hType)
	local crBonus = GetCombatRatingBonus(hType)
	local crHit = 0
	if(hType == 6) then crHit = GetHitModifier() end
	if(hType == 7) then crHit = GetSpellHitModifier() end
	if(hType == 8) then crHit = GetHitModifier() end
	if(crActual == nil) then crActual = 0 end
	if(crBonus == nil) then crBonus = 0 end
	if(crHit == nil) then crHit = 0 end
	return (crActual + crBonus + crHit)
end

local function UpdateStats()
	local _, _, cStatID = UnitClass("player")
	local pCrit = format("%.2f%%", GetCritChance())
	local sCrit = format("%.2f%%", GetSpellCritChance())
	local rCrit = format("%.2f%%", GetRangedCritChance())
	local rBlock = format("%.2f%%", GetBlockChance())
	local rDodge = format("%.2f%%", GetDodgeChance())
	local rMeleeHit = format("%.2f%%", GetCombatHit(6))
	local rSpellHit = format("%.2f%%", GetCombatHit(7))
	local rRangeHit = format("%.2f%%", GetCombatHit(8))
	local rParry = format("%.2f%%", GetParryChance())
	local rHealRaw = format("%.0f", GetSpellBonusHealing())
	local spOne = format("%.0f", GetSpellBonusDamage(1))
	local spTwo = format("%.0f", GetSpellBonusDamage(2))
	local spThree = format("%.0f", GetSpellBonusDamage(3))
	local spFour = format("%.0f", GetSpellBonusDamage(4))
	local spFive = format("%.0f", GetSpellBonusDamage(5))
	local spSix = format("%.0f", GetSpellBonusDamage(6))
	local spSeven = format("%.0f", GetSpellBonusDamage(7))
	local pHit, base = GetManaRegen()
	local cSpeed, rSpeed, fSpeed, sSpeed = GetUnitSpeed("player")
	local bPwr, pPwr, nPwr = UnitAttackPower("player")
	local rbPwr, rpPwr, rnPwr = UnitRangedAttackPower("player")
	local ePwr = bPwr + pPwr + nPwr
	local rePwr = rbPwr + rpPwr + rnPwr
	local _, pStr, _, _ = UnitStat("player",1)
	local _, pAgi, _, _ = UnitStat("player",2)
	local _, pSta, _, _ = UnitStat("player",3)
	local _, pInt, _, _ = UnitStat("player",4)
	pAttribArea, pAttribStat = " ", " "
	UpdateTextStat("Attack",ePwr)
	UpdateTextStat("Ranged",rePwr)
	UpdateTextStat("Healing",rHealRaw)
	UpdateTextStat("Physical",spOne)
	UpdateTextStat("Holy",spTwo)
	UpdateTextStat("Fire",spThree)
	UpdateTextStat("Nature",spFour)
	UpdateTextStat("Frost",spFive)
	UpdateTextStat("Shadow",spSix)
	UpdateTextStat("Arcane",spSeven)
	UpdateTextStat("","")
	UpdateTextStat("Block",rBlock)
	UpdateTextStat("Dodge",rDodge)
	UpdateTextStat("Parry",rParry)
	UpdateTextStat("","")
	UpdateTextStat("Melee Hit",rMeleeHit)
	UpdateTextStat("Melee Crit",pCrit)
	UpdateTextStat("Spell Hit",rSpellHit)
	UpdateTextStat("Spell Crit",sCrit)
	UpdateTextStat("Ranged Hit",rRangeHit)
	UpdateTextStat("Ranged Crit",rCrit)
	UpdateTextStat("","")
	UpdateTextStat("Mana Regen",format("%.2f", (base * 2)))
	UpdateTextStat("Mana Regen",format("%.2f", (pHit * 2)))
	UpdateTextStat("","")
	UpdateTextStat("Move Speed",format("%.2f", cSpeed))
	UpdateTextStat("","")
	UpdateTextStat("Stamina","")
	UpdateTextStat("+Health",format("%.0f", (pSta * 10)))
	UpdateTextStat("","")
	UpdateTextStat("Agility","")
	UpdateTextStat("+Armor",format("%.0f", pAgi))
	if(cStatID == 1) then
		UpdateTextStat("+Ranged Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("+Block",format("%.0f", math.floor(pStr / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
	end
	if(cStatID == 2) then
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("+Block",format("%.0f", math.floor(pStr / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 54)))
	end
	if(cStatID == 3) then
		UpdateTextStat("+Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Ranged Attack",format("%.0f", (pAgi * 2)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 53)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 26)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
	end
	if(cStatID == 4) then
		UpdateTextStat("+Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Ranged Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 29)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 14.5)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
	end
	if(cStatID == 5) then
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 59.2)))
	end
	if(cStatID == 7) then
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("+Block",format("%.0f", math.floor(pStr / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 59.5)))
	end
	if(cStatID == 8) then
		UpdateTextStat("+Dodge",format("%.0f%%", math.floor(pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 59.5)))
	end
	if(cStatID == 9) then
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 60.6)))
	end
	if(cStatID == 11) then
		UpdateTextStat("+Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 60)))
	end
	UpdateTextStat("+Mana",format("%.0f", math.floor(pInt * 15)))
	UpdateTextStat("","")
end

local function CombatAll() 
	local pgNum = GetNumGroupMembers()
	ShowText[1] = "\n"
	ShowText[2] = "\n"
	ShowText[3] = "\n"
	ShowText[4] = "\n"

	playCombat(playStatBase)
	if(pgNum > 1) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playCombat(poneStatBase)
	end
	if(pgNum > 2) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playCombat(ptwoStatBase)
	end
	if(pgNum > 3) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playCombat(pthrStatBase)
	end
	if(pgNum > 4) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playCombat(pfouStatBase)
	end			

	fCombat[4]:SetText(ShowText[1])
	fCombat[5]:SetText(ShowText[2])
	fCombat[6]:SetText(ShowText[3])
	fCombat[7]:SetText(ShowText[4])
end

local function CombatQuick()
	local pgNum = GetNumGroupMembers()
	ShowText[1] = "\n"
	ShowText[2] = "\n"
	ShowText[3] = "\n"
	ShowText[4] = "\n"

	playQuick(playStatBase)
	if(pgNum > 1) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playQuick(poneStatBase)
	end
	if(pgNum > 2) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playQuick(ptwoStatBase)
	end
	if(pgNum > 3) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playQuick(pthrStatBase)
	end
	if(pgNum > 4) then
		ShowText[1] = ShowText[1] .. "\n\n"
		ShowText[2] = ShowText[2] .. "\n\n"
		ShowText[3] = ShowText[3] .. "\n\n"
		ShowText[4] = ShowText[4] .. "\n\n"
		playQuick(pfouStatBase)
	end		

	fCombat[4]:SetText(ShowText[1])
	fCombat[5]:SetText(ShowText[2])
	fCombat[6]:SetText(ShowText[3])
	fCombat[7]:SetText(ShowText[4])
end

local function GetQuestColor(cLevel)
	local ncLvl = tonumber(cLevel)
	if(ncLvl ~= nil) then
		local dColor = GetQuestDifficultyColor(ncLvl)
		local dConvert = string.format("%02x%02x%02x", (dColor.r * 255), (dColor.g * 255), (dColor.b * 255))
		return string.upper("ff" .. dConvert)
	end
	return "FFFFFFFF"
end

local function ColorTitle(tTitle, lTitle)
	return "\124c" .. GetQuestColor(lTitle) .. tTitle .. "\124r"
end

local function UpdateZoneText(tZone, lZone, MZone)
	qText = qText .. "\n" .. tZone
	xText = xText .. "\n" .. lZone
	eText = eText .. "\n" .. MZone
end

local function UpdateColorZone(tZone, lZone, MZone)
	qText = qText .. "\n" .. ColorTitle(tZone, MZone) 
	xText = xText .. "\n" .. lZone
	eText = eText .. "\n" .. MZone
end

local function UpdateExperience()
	local pLvl = UnitLevel("player")
	local pExp = UnitXP("player")
	local pExpMax = UnitXPMax("player")
	local tExp = pExpMax - pExp
	qText, xText, eText = "", "", ""
	for i=-3, 3 do
		local cLvlXP = pLvl + i
		local pXPLvl = ((cLvlXP * 5) + 45)
		local tExpCount = tExp / pXPLvl
		if(cLvlXP < 1) then cLvlXP = 1; pXPLvl = ((cLvlXP * 5) + 45) end
		pXPLvl = ((cLvlXP * 5) + 45)
		UpdateZoneText("NPC Level " .. cLvlXP .. " (" .. pXPLvl .. " xp)","-",format("%.0f", tExpCount))
	end
	UpdateZoneText("Experience","-",tExp)
	if(tonumber(charStatBase[1]) ~= nil) then
		if(tonumber(charStatBase[1]) > 0) then 
			UpdateZoneText("Average iLvl", " ", format("%.0f", (tonumber(charStatBase[2]) / tonumber(charStatBase[1]))))
		end
	end
	UpdateZoneText(" "," "," ")
end

local function UpdateQuestInfo()
	local tGold = 0
	local nEntries, nQuests = GetNumQuestLogEntries()
	UpdateZoneText("Quests","Gold","Level")
	UpdateZoneText(" "," "," ")
	for i=1, nEntries do
		local qTitle, qLevel, _, qHeader, _, _, _, qID, _, _, _, _, _, _, _, _, _, _ = GetQuestLogTitle(i)
		if(qHeader == true) then UpdateZoneText(qTitle,"","") end
		if(qHeader == false) then 
			local qMoney = GetQuestLogRewardMoney(qID)
			local qLB = GetNumQuestLeaderBoards(i)
			local qColor = GetQuestColor(qLevel)
			local nTitle = "\124c" .. qColor .. qTitle .. "\124r"
			UpdateZoneText(nTitle,GetCoinTextureString(qMoney, 8),qLevel)
			for z=1, qLB do
				local tQuest, _, _ = GetQuestLogLeaderBoard(z,i)
				local hTitle = "\124cFFFFFFFF" .. tQuest .. "\124r"
				if(tQuest ~= nil) then UpdateZoneText(" -" .. hTitle,"","") end
			end
			tGold = tGold + qMoney
			UpdateZoneText(" "," "," ")
		end
	end
	UpdateZoneText(" "," "," ")
	UpdateZoneText("Total Gold",GetCoinTextureString(tGold, 8),"-")
	UpdateZoneText(" "," "," ")
end

local function IconButton(bUsed, iUsed)
	local iArea = bUsed:CreateTexture(nil,"OVERLAY")
	iArea:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_" .. iUsed)
	iArea:SetPoint("CENTER")
	iArea:SetSize(24,24)
end

local function GetRaidIcons()
	for i=1,8 do
		if(i == 1) then IconButton(fRaid[2], 1) end
		if(i == 2) then IconButton(fRaid[3], 2) end
		if(i == 3) then IconButton(fRaid[4], 3) end
		if(i == 4) then IconButton(fRaid[5], 4) end
		if(i == 5) then IconButton(fRaid[6], 5) end
		if(i == 6) then IconButton(fRaid[7], 6) end
		if(i == 7) then IconButton(fRaid[8], 7) end
		if(i == 8) then IconButton(fRaid[9], 8) end
	end
end

local function ShowDebuff()
	local nUsed = "Player\n\n"
	local tUsed = "Time\n\n"
	for dIndex=1,40 do
		local dName, _, _, _, _, dTime = UnitBuff("player", dIndex)
		if(dName ~= nil) then
			local gUsed = (dTime - GetTime())
			if(gUsed < 0) then gUsed = 0 end
			nUsed = nUsed .. "\124cFFFFFFFF" .. dName .. "\124r\n"
			tUsed = tUsed .. "\124cFFFFFFFF" .. format("%.2f", gUsed ) ..  "\124r\n"
		end
	end
	for dIndex=1,40 do
		local dName, _, _, _, _, dTime = UnitDebuff("player", dIndex)
		if(dName ~= nil) then 
			local gUsed = (dTime - GetTime())
			if(gUsed < 0) then gUsed = 0 end
			nUsed = nUsed .. "\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:0\124t\124cFFFFFF00" .. dName .. "\124r\n"
			tUsed = tUsed .. "\124cFFFFFFFF" .. format("%.2f", gUsed ) ..  "\124r\n"
		end
	end
	nUsed = nUsed .. "\nTarget\n\n"
	tUsed = tUsed .. "\n\n\n"
	for dIndex=1,40 do
		local dName, _, _, _, _, dTime = UnitBuff("target", dIndex)
		if(dName ~= nil) then
			local gUsed = (dTime - GetTime())
			if(gUsed < 0) then gUsed = 0 end
			nUsed = nUsed .. "\124cFFFFFFFF" .. dName .. "\124r\n"
			tUsed = tUsed .. "\124cFFFFFFFF" .. format("%.2f", gUsed ) ..  "\124r\n"
		end
	end
	for dIndex=1,40 do
		local dName, _, _, _, _, dTime = UnitDebuff("target", dIndex)
		if(dName ~= nil) then 
			local gUsed = (dTime - GetTime())
			if(gUsed < 0) then gUsed = 0 end
			nUsed = nUsed .. "\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:0\124t\124cFFFFFF00" .. dName .. "\124r\n"
			tUsed = tUsed .. "\124cFFFFFFFF" .. format("%.2f", gUsed ) ..  "\124r\n"
		end
	end
	fDebuff[4]:SetText(nUsed)
	fDebuff[5]:SetText(tUsed)
end

local function CastRole()
	local rSuccess = C_ChatInfo.RegisterAddonMessagePrefix("AtlasArenaAddon")
	charStatBase[5] = "YELL"
end

local function UpdateRoles() 
	local pLvl = UnitLevel("player")
	local cName, _, _ = UnitClass("player")
	local pRole = pLvl .. " " .. cName .. " " .. charStatBase[3] .. " " .. charStatBase[4]
	fParty[88]:SetText(pRole)
end

local function SendRole()
	local pLvl = UnitLevel("player")
	local cName, _, _ = UnitClass("player")
	local pRole = pLvl .. "?" .. cName .. "?" .. charStatBase[3] .. "?" .. charStatBase[4]
	local cSuccess = C_ChatInfo.SendAddonMessage("AtlasArenaAddon",pRole,charStatBase[5])
end

local function UpdatePost(upUsed, upDesc, upPC)
	upUsed:SetScript("OnMouseDown", function (self, button)
			if(button == "LeftButton") then InviteUnit(upPC) end 
		end)
	upUsed:SetText(upDesc)
	upUsed:Show()
end

local function HidePost()
	for h=48,87 do fParty[h]:Hide() end
end

local function ShowRoles() 
	local iPost = 48
	HidePost()
	table.foreach(pgroStatBase, function (k,v)
		local l, n, r, d = strsplit("?",v)
		local pdesc = ""
		local adesc = tostring(k)
		if(d ~= nil) then pdesc = pdesc .. d .. "\n" end
		if(l ~= nil) then pdesc = pdesc .. l .. " " end
		if(n ~= nil) then pdesc = pdesc .. n .. " " end 
		if(r ~= nil) then pdesc = pdesc .. r .. "\n" end
		if(adesc ~= nil) then pdesc = pdesc .. adesc end
		UpdatePost(fParty[iPost], pdesc, adesc)
		if(iPost < 88) then  iPost = iPost + 1 end
	end)
end

local function ReceiveRole(self, ...)
	local _, oText, _, oSend, _, _, _, _, _ = ...
	pgroStatBase[oSend] = oText
	ShowRoles()
end

local function CreateSpells()
	local px, py = 10, -32
	for tx=2, 4 do
		local _, _, to, ne = GetSpellTabInfo(tx)
		for cs=to + 1, to + ne do
			local csn, _ = GetSpellBookItemName(cs, BOOKTYPE_SPELL)
			local fsn = cs + 1
			fSpells[fsn] = CreateFrame("Button","fs" .. tostring(fsn),fSpells[1],"SecureActionButtonTemplate, UIPanelButtonTemplate")
			fSpells[fsn]:SetSize(32,32)
			fSpells[fsn]:EnableMouse(true)
			fSpells[fsn]:RegisterForClicks("AnyUp")
			fSpells[fsn]:SetNormalFontObject("GameFontNormal")
			fSpells[fsn]:SetPoint("TOPLEFT",px,py)
			fSpells[fsn]:SetAttribute("type1", "macro")
			fSpells[fsn]:SetAttribute("macrotext1", "/cast " .. csn .. "\n/say " .. csn)
			UpdateSpellIcon(csn, fSpells[fsn])
			px = px + 32
			if(px > 380) then py = py - 32; px = 10 end
		end
		py = py - 32
		px = 10
	end
end

local function ShowStats()
	UpdatePartyStats()
	if(pQuick == 0) then CombatAll() end
	if(pQuick == 1) then CombatQuick() end
	ShowDebuff()
end

local function ShowGear()
	UpdateStats()
	fGear[4]:SetText(pAttribArea) ; fGear[5]:SetText(pAttribStat)
end

local function ShowQuesting()
	UpdateExperience()
	UpdateQuestInfo()
	fQuest[4]:SetText(qText)
	fQuest[5]:SetText(xText)
	fQuest[6]:SetText(eText)
end

local function LoadStart()
	UpdateClassSpells()
	GetRaidIcons()
	HidePost()
	CastRole()
	CreateSpells()
end

local function ResetAllAreas()
	playStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
	poneStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
	ptwoStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
	pthrStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
	pfouStatBase = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}

	charStatBase = {"","","","","",""}
	grouStatBase = {}
	ShowText = {"","","",""}

	pAttribArea, pAttribStat = "Gear", "Stats"
	qText, xText, eText = "", "", ""
	pgroStatBase = {}

    	if(MerchantFrame:IsVisible() == false) then b3:Hide() end
	HidePost()
end

fPlayer[1] = CreateFrame("Button","TargetMob",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
fPlayer[1]:EnableMouse(true)
fPlayer[1]:SetMovable(true)
fPlayer[1]:SetClampedToScreen(true)
fPlayer[1]:RegisterForClicks("AnyDown")
fPlayer[1]:RegisterForDrag("RightButton")
fPlayer[1]:SetScript("OnDragStart", fPlayer[1].StartMoving)
fPlayer[1]:SetScript("OnDragStop", fPlayer[1].StopMovingOrSizing)
fPlayer[1]:SetAttribute("type1", "target")
fPlayer[1]:SetAttribute("shift-type1", "macro")
fPlayer[1]:SetAttribute("shift-type2", "macro")
fPlayer[1]:SetAttribute("unit","player")
fPlayer[1]:SetPoint("TOPLEFT",10,20)
fPlayer[1]:SetSize(420, 110)

fPlayer[2] = fPlayer[1]:CreateTexture(nil,"OVERLAY")
fPlayer[2]:SetColorTexture(0,0,1)
fPlayer[2]:SetAlpha(0.48)
fPlayer[2]:SetPoint("TOPLEFT",10,-10)
fPlayer[2]:SetSize(400,20)

fPlayer[3] = fPlayer[1]:CreateTexture(nil,"OVERLAY")
fPlayer[3]:SetColorTexture(0,0,1)
fPlayer[3]:SetAlpha(0.48)
fPlayer[3]:SetPoint("TOPLEFT",10,-30)
fPlayer[3]:SetSize(400,20)

fPlayer[4] = fPlayer[1]:CreateTexture(nil,"OVERLAY")
fPlayer[4]:SetColorTexture(0,0,1)
fPlayer[4]:SetAlpha(0.48)
fPlayer[4]:SetPoint("TOPLEFT",10,-50)
fPlayer[4]:SetSize(400,20)

fPlayer[5] = fPlayer[1]:CreateTexture(nil,"OVERLAY")
fPlayer[5]:SetColorTexture(0,0,1)
fPlayer[5]:SetAlpha(0.48)
fPlayer[5]:SetPoint("TOPLEFT",10,-70)
fPlayer[5]:SetSize(400,20)

fPlayer[6] = fPlayer[1]:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")
fPlayer[6]:SetPoint("TOPLEFT",10, -10)
fPlayer[6]:SetSize(400,90)
fPlayer[6]:SetJustifyH("LEFT")
fPlayer[6]:SetTextColor(1,1,1)

fPlayer[7] = fPlayer[1]:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")
fPlayer[7]:SetPoint("TOPLEFT",10, -10)
fPlayer[7]:SetSize(400,90)
fPlayer[7]:SetJustifyH("RIGHT")
fPlayer[7]:SetTextColor(1,1,1)

fTarget[1] = CreateFrame("Button","TargetPlayer",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
fTarget[1]:EnableMouse(true)
fTarget[1]:SetMovable(true)
fTarget[1]:SetClampedToScreen(true)
fTarget[1]:RegisterForDrag("RightButton")
fTarget[1]:SetScript("OnDragStart", fTarget[1].StartMoving)
fTarget[1]:SetScript("OnDragStop", fTarget[1].StopMovingOrSizing)
fTarget[1]:RegisterForClicks("AnyUp")
fTarget[1]:SetAttribute("type1", "macro")
fTarget[1]:SetAttribute("shift-type1", "macro")
fTarget[1]:SetAttribute("macrotext1", "/dismount\n/cleartarget\n/stopcasting\n/stopattack\n/targetenemy [noexists][dead]\n/petattack\n/startattack")
fTarget[1]:SetAttribute("shift-macrotext1", "/cleartarget\n/petfollow\n/stopcasting\n/stopattack\n/say is not attacking")
fTarget[1]:SetPoint("TOPLEFT",340,20)
fTarget[1]:SetSize(420, 80)

fTarget[2] = fTarget[1]:CreateTexture(nil,"OVERLAY")
fTarget[2]:SetColorTexture(0,0,1)
fTarget[2]:SetAlpha(0.48)
fTarget[2]:SetPoint("TOPLEFT",10,-10)
fTarget[2]:SetSize(400,30)

fTarget[3] = fTarget[1]:CreateTexture(nil,"OVERLAY")
fTarget[3]:SetColorTexture(0,0,1)
fTarget[3]:SetAlpha(0.48)
fTarget[3]:SetPoint("TOPLEFT",10,-40)
fTarget[3]:SetSize(400,30)

fTarget[4] = fTarget[1]:CreateTexture(nil,"OVERLAY")
fTarget[4]:SetColorTexture(0,0,1)
fTarget[4]:SetAlpha(0)
fTarget[4]:SetPoint("TOPLEFT",10,-40)
fTarget[4]:SetSize(400,15)

fTarget[5] = fTarget[1]:CreateTexture(nil,"OVERLAY")
fTarget[5]:SetColorTexture(0,0,1)
fTarget[5]:SetAlpha(0)
fTarget[5]:SetPoint("TOPLEFT",10,-55)
fTarget[5]:SetSize(400,15)

fTarget[6] = fTarget[1]:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
fTarget[6]:SetPoint("TOPLEFT",10, -10)
fTarget[6]:SetSize(400,60)
fTarget[6]:SetJustifyH("LEFT")
fTarget[6]:SetTextColor(1,1,1)

fTarget[7] = fTarget[1]:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
fTarget[7]:SetPoint("TOPLEFT",10, -10)
fTarget[7]:SetSize(400,60)
fTarget[7]:SetJustifyH("RIGHT")
fTarget[7]:SetTextColor(1,1,1)

fGear[1] = CreateFrame("Frame","fg1",UIParent,"BasicFrameTemplate")
fGear[1]:SetSize(460,280)
fGear[1]:SetAlpha(0.90)
fGear[1]:SetPoint("CENTER",-330,0)
fGear[1]:SetMovable(true)
fGear[1]:EnableMouse(true)
fGear[1]:SetClampedToScreen(true)
fGear[1]:RegisterForDrag("RightButton")
fGear[1]:SetScript("OnDragStart", fGear[1].StartMoving)
fGear[1]:SetScript("OnDragStop", fGear[1].StopMovingOrSizing)

fGear[3] = CreateFrame("ScrollFrame","fg3",fGear[1],"UIPanelScrollFrameTemplate")
fGear[2] = CreateFrame("Frame","fg2",fGear[3],"InsetFrameTemplate2")
fGear[2]:SetSize(440,1152)
fGear[2]:SetPoint("TOPLEFT",0,0)
fGear[3]:SetPoint("TOPLEFT",0,-22)
fGear[3]:SetSize(432,258)
fGear[3]:SetScrollChild(fGear[2])

fGear[4] = fGear[2]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fGear[4]:SetPoint("TOPLEFT", 10, -28)
fGear[4]:SetWidth(400)
fGear[4]:SetJustifyH("LEFT")

fGear[5] = fGear[2]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fGear[5]:SetPoint("TOPLEFT", 10, -28)
fGear[5]:SetWidth(400)
fGear[5]:SetJustifyH("RIGHT")
fGear[5]:SetTextColor(1,1,1)

fCombat[1] = CreateFrame("Frame","fc1",UIParent,"BasicFrameTemplate")
fCombat[1]:SetSize(460,280)
fCombat[1]:SetAlpha(.90)
fCombat[1]:SetPoint("CENTER", 0, 0)
fCombat[1]:SetMovable(true)
fCombat[1]:EnableMouse(true)
fCombat[1]:SetClampedToScreen(true)
fCombat[1]:RegisterForDrag("RightButton")
fCombat[1]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then ResetAllAreas(); ShowStats(); end
end)
fCombat[1]:SetScript("OnDragStart", fCombat[1].StartMoving)
fCombat[1]:SetScript("OnDragStop", fCombat[1].StopMovingOrSizing)

fCombat[2] = CreateFrame("ScrollFrame","fc2",fCombat[1],"UIPanelScrollFrameTemplate")
fCombat[3] = CreateFrame("Frame","fc3",fCombat[2],"InsetFrameTemplate2")
fCombat[2]:SetPoint("TOPLEFT",0,-22)
fCombat[2]:SetSize(432,258)
fCombat[2]:SetScrollChild(fCombat[3])
fCombat[3]:SetSize(440,1152)
fCombat[3]:SetPoint("TOPLEFT",0,0)

fCombat[4] = fCombat[3]:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
fCombat[4]:SetPoint("TOPLEFT",10, -10)
fCombat[4]:SetWidth(70)
fCombat[4]:SetJustifyH("RIGHT")

fCombat[5] = fCombat[3]:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
fCombat[5]:SetPoint("TOPLEFT", 90, -10)
fCombat[5]:SetWidth(90)
fCombat[5]:SetJustifyH("RIGHT")

fCombat[6] = fCombat[3]:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
fCombat[6]:SetPoint("TOPLEFT", 190, -10)
fCombat[6]:SetWidth(90)
fCombat[6]:SetJustifyH("RIGHT")

fCombat[7] = fCombat[3]:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
fCombat[7]:SetPoint("TOPLEFT", 290, -10)
fCombat[7]:SetWidth(110)
fCombat[7]:SetJustifyH("RIGHT")

fQuest[1] = CreateFrame("Frame","fq1",UIParent,"BasicFrameTemplate")
fQuest[1]:SetSize(500,300)
fQuest[1]:SetAlpha(.90)
fQuest[1]:SetPoint("CENTER",330,0)
fQuest[1]:SetMovable(true)
fQuest[1]:EnableMouse(true)
fQuest[1]:SetClampedToScreen(true)
fQuest[1]:RegisterForDrag("RightButton")
fQuest[1]:SetScript("OnDragStart", fQuest[1].StartMoving)
fQuest[1]:SetScript("OnDragStop", fQuest[1].StopMovingOrSizing)

fQuest[2] = CreateFrame("ScrollFrame","fq2",fQuest[1],"UIPanelScrollFrameTemplate")
fQuest[3] = CreateFrame("Frame","fq3",fQuest[2],"InsetFrameTemplate2")
fQuest[2]:SetPoint("TOPLEFT",0,-22)
fQuest[2]:SetSize(472,272)
fQuest[2]:SetScrollChild(fQuest[3])
fQuest[3]:SetSize(480,720)
fQuest[3]:SetPoint("TOPLEFT",0,0)

fQuest[4] = fQuest[3]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fQuest[4]:SetPoint("TOPLEFT", 10, -10)
fQuest[4]:SetWidth(460)
fQuest[4]:SetJustifyH("LEFT")

fQuest[5] = fQuest[3]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fQuest[5]:SetPoint("TOPLEFT", 240, -10)
fQuest[5]:SetWidth(140)
fQuest[5]:SetJustifyH("RIGHT")
fQuest[5]:SetTextColor(1,1,1)

fQuest[6] = fQuest[3]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fQuest[6]:SetPoint("TOPLEFT", 10, -10)
fQuest[6]:SetWidth(460)
fQuest[6]:SetJustifyH("RIGHT")
fQuest[6]:SetTextColor(1,1,1,1)

fRaid[1] = CreateFrame("Frame","TargetBar",UIParent,"BasicFrameTemplate")
fRaid[1]:SetSize(420,236)
fRaid[1]:SetAlpha(.90)
fRaid[1]:SetPoint("CENTER",0,-170)
fRaid[1]:EnableMouse(true)
fRaid[1]:SetMovable(true)
fRaid[1]:SetClampedToScreen(true)
fRaid[1]:RegisterForDrag("RightButton")
fRaid[1]:SetScript("OnDragStart", fRaid[1].StartMoving)
fRaid[1]:SetScript("OnDragStop", fRaid[1].StopMovingOrSizing)

for rf=1,8 do
	local uf = rf + 1
	fRaid[uf] = CreateFrame("Button","fr" .. tostring(uf),fRaid[1],"UIPanelButtonTemplate")
	fRaid[uf]:SetSize(40,40)
	fRaid[uf]:EnableMouse(true)
	fRaid[uf]:SetScript("OnMouseDown", function (self, button)
		if(button == "LeftButton") then SetRaidTarget("target", rf); end
	end)
end

fRaid[2]:SetPoint("TOPLEFT",10,-26)
fRaid[3]:SetPoint("TOPLEFT",50,-26)
fRaid[4]:SetPoint("TOPLEFT",90,-26)
fRaid[5]:SetPoint("TOPLEFT",130,-26)
fRaid[6]:SetPoint("TOPLEFT",170,-26)
fRaid[7]:SetPoint("TOPLEFT",210,-26)
fRaid[8]:SetPoint("TOPLEFT",250,-26)
fRaid[9]:SetPoint("TOPLEFT",290,-26)

for bf=10,50 do
	fRaid[bf] = CreateFrame("Button","fr" .. tostring(bf),fRaid[1],"SecureActionButtonTemplate, UIPanelButtonTemplate")
	fRaid[bf]:SetSize(40,40)
	fRaid[bf]:EnableMouse(true)
	fRaid[bf]:RegisterForClicks("AnyUp")
	fRaid[bf]:SetNormalFontObject("GameFontNormal")
end

fRaid[10]:SetPoint("TOPLEFT",330,-26)
fRaid[11]:SetPoint("TOPLEFT",10,-66)
fRaid[12]:SetPoint("TOPLEFT",50,-66)
fRaid[13]:SetPoint("TOPLEFT",90,-66)
fRaid[14]:SetPoint("TOPLEFT",130,-66)
fRaid[15]:SetPoint("TOPLEFT",170,-66)
fRaid[16]:SetPoint("TOPLEFT",210,-66)
fRaid[17]:SetPoint("TOPLEFT",250,-66)
fRaid[18]:SetPoint("TOPLEFT",290,-66)
fRaid[19]:SetPoint("TOPLEFT",330,-66)
fRaid[20]:SetPoint("TOPLEFT",370,-66)
fRaid[21]:SetPoint("TOPLEFT",10,-106)
fRaid[22]:SetPoint("TOPLEFT",50,-106)
fRaid[23]:SetPoint("TOPLEFT",90,-106)
fRaid[24]:SetPoint("TOPLEFT",130,-106)
fRaid[25]:SetPoint("TOPLEFT",170,-106)
fRaid[26]:SetPoint("TOPLEFT",210,-106)
fRaid[27]:SetPoint("TOPLEFT",250,-106)
fRaid[28]:SetPoint("TOPLEFT",290,-106)
fRaid[29]:SetPoint("TOPLEFT",330,-106)
fRaid[30]:SetPoint("TOPLEFT",370,-106)
fRaid[31]:SetPoint("TOPLEFT",10,-146)
fRaid[32]:SetPoint("TOPLEFT",50,-146)
fRaid[33]:SetPoint("TOPLEFT",90,-146)
fRaid[34]:SetPoint("TOPLEFT",130,-146)
fRaid[35]:SetPoint("TOPLEFT",170,-146)
fRaid[36]:SetPoint("TOPLEFT",210,-146)
fRaid[37]:SetPoint("TOPLEFT",250,-146)
fRaid[38]:SetPoint("TOPLEFT",290,-146)
fRaid[39]:SetPoint("TOPLEFT",330,-146)
fRaid[40]:SetPoint("TOPLEFT",370,-146)
fRaid[41]:SetPoint("TOPLEFT",10,-186)
fRaid[42]:SetPoint("TOPLEFT",50,-186)
fRaid[43]:SetPoint("TOPLEFT",90,-186)
fRaid[44]:SetPoint("TOPLEFT",130,-186)
fRaid[45]:SetPoint("TOPLEFT",170,-186)
fRaid[46]:SetPoint("TOPLEFT",210,-186)
fRaid[47]:SetPoint("TOPLEFT",250,-186)
fRaid[48]:SetPoint("TOPLEFT",290,-186)
fRaid[49]:SetPoint("TOPLEFT",330,-186)
fRaid[50]:SetPoint("TOPLEFT",370,-186)

fOption[1] = CreateFrame("Frame","AdvancedBar",UIParent,"TooltipBorderedFrameTemplate")
fOption[1]:SetSize(420,60)
fOption[1]:SetAlpha(.90)
fOption[1]:SetPoint("CENTER",0,-170)
fOption[1]:EnableMouse(true)
fOption[1]:SetMovable(true)
fOption[1]:SetClampedToScreen(true)
fOption[1]:RegisterForDrag("RightButton")
fOption[1]:RegisterEvent("CHAT_MSG_ADDON")
fOption[1]:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
fOption[1]:RegisterEvent("MERCHANT_SHOW")
fOption[1]:RegisterEvent("MERCHANT_CLOSED")
fOption[1]:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE")
fOption[1]:RegisterEvent("QUEST_DETAIL")
fOption[1]:RegisterEvent("UNIT_INVENTORY_CHANGED")
fOption[1]:RegisterEvent("GROUP_ROSTER_UPDATE")
fOption[1]:RegisterEvent("RAID_ROSTER_UPDATE")
fOption[1]:RegisterEvent("UNIT_HEALTH")
fOption[1]:RegisterEvent("UNIT_POWER_FREQUENT")
fOption[1]:RegisterEvent("UNIT_TARGET")
fOption[1]:RegisterEvent("UNIT_COMBAT")
fOption[1]:RegisterEvent("TAXIMAP_OPENED")
fOption[1]:RegisterEvent("PLAYER_LOGIN")
fOption[1]:RegisterEvent("PLAYER_STARTED_MOVING")
fOption[1]:RegisterEvent("PLAYER_STOPPED_MOVING")
fOption[1]:SetScript("OnEvent", function(self, event, ...)
	if(event == "CHAT_MSG_ADDON") then ReceiveRole(self, ...) end
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then SendStatus(self, CombatLogGetCurrentEventInfo()) ; ShowStats() end
	if(event == "GROUP_ROSTER_UPDATE") then ShowStats() ; UpdateClassSpells() ; end
	if(event == "MERCHANT_SHOW") then fOption[2]:Show() end
	if(event == "MERCHANT_CLOSED") then fOption[2]:Hide() end
	if(event == "PLAYER_AVG_ITEM_LEVEL_UPDATE") then ShowGear() end
	if(event == "PLAYER_EQUIPMENT_CHANGED") then ShowGear() end
	if(event == "PLAYER_LOGIN") then LoadStart() ; end
	if(event == "PLAYER_STARTED_MOVING") then GetPlayerStat("player",fPlayer[6],fPlayer[7]) ; end
	if(event == "PLAYER_STOPPED_MOVING") then GetPlayerStat("player",fPlayer[6],fPlayer[7]) ; end
	if(event == "QUEST_DETAIL") then AcceptQuest() end
	if(event == "RAID_ROSTER_UPDATE") then ShowStats() ; UpdateClassSpells() ; end
	if(event == "TAXIMAP_OPENED") then Dismount() ; end
	if(event == "UNIT_HEALTH") then ShowStats() end
	if(event == "UNIT_POWER_FREQUENT") then ShowStats() end
	if(event == "UNIT_TARGET") then ShowStats() end
	if(event == "UNIT_INVENTORY_CHANGED") then ShowGear() end
end)
fOption[1]:SetScript("OnDragStart", fOption[1].StartMoving)
fOption[1]:SetScript("OnDragStop", fOption[1].StopMovingOrSizing)

for o=2,11 do
	fOption[o] = CreateFrame("Button","fo" .. tostring(o),fOption[1],"UIPanelButtonTemplate")
	fOption[o]:SetSize(40,40)
	fOption[o]:EnableMouse(true)
	fOption[o]:SetNormalFontObject("GameFontNormal")
end

fOption[2]:SetPoint("TOPLEFT",330,-10)
fOption[2]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then VendorGray(); end
end)
fOption[2]:SetText("$")

fOption[3]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then pQuick = 0 ; ShowStats() ; fCombat[1]:Show() end 
end)
fOption[3]:SetPoint("TOPLEFT",10,-10)
fOption[3]:SetText("A")

fOption[4]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowQuesting() ; fQuest[1]:Show() end 
end)
fOption[4]:SetPoint("TOPLEFT",50,-10)
fOption[4]:SetText("Q")

fOption[5]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); fGear[1]:Show() end 
end)
fOption[5]:SetPoint("TOPLEFT",130,-10)
fOption[5]:SetText("C")

fOption[6]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); fThreat[1]:Show() end 
end)
fOption[6]:SetPoint("TOPLEFT",90,-10)
fOption[6]:SetText("T")

fOption[7]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then pQuick = 1 ; ShowStats() ; fCombat[1]:Show() end 
end)
fOption[7]:SetPoint("TOPLEFT",170,-10)
fOption[7]:SetText("O")

fOption[8]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then fRaid[1]:Show(); fSpells[1]:Show() end 
end)
fOption[8]:SetPoint("TOPLEFT",250,-10)
fOption[8]:SetText("+")

fOption[9]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then fParty[1]:Show() end 
end)
fOption[9]:SetPoint("TOPLEFT",210,-10)
fOption[9]:SetText("P")

fOption[10]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then fDebuff[1]:Show() end 
end)
fOption[10]:SetPoint("TOPLEFT",290,-10)
fOption[10]:SetText("D")

fOption[11]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then
		if(DEFAULT_CHAT_FRAME:IsVisible() == true) then DEFAULT_CHAT_FRAME:Hide() ; return ; end
		if(DEFAULT_CHAT_FRAME:IsVisible() == false) then DEFAULT_CHAT_FRAME:Show() ; return ; end
	end 
end)
fOption[11]:SetPoint("TOPLEFT",370,-10)
fOption[11]:SetText("[__]")

fThreat[1] = CreateFrame("Frame","playThreat",UIParent,"BasicFrameTemplate")
fThreat[1]:SetSize(420,150)
fThreat[1]:SetAlpha(.90)
fThreat[1]:SetPoint("CENTER", 0, 0)
fThreat[1]:SetMovable(true)
fThreat[1]:EnableMouse(true)
fThreat[1]:SetClampedToScreen(true)
fThreat[1]:RegisterForDrag("RightButton")
fThreat[1]:SetScript("OnDragStart", fThreat[1].StartMoving)
fThreat[1]:SetScript("OnDragStop", fThreat[1].StopMovingOrSizing)

fThreat[2] = fThreat[1]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fThreat[2]:SetPoint("TOPLEFT",5, -5)
fThreat[2]:SetSize(410,140)
fThreat[2]:SetJustifyH("LEFT")

fParty[1] = CreateFrame("Frame","fpg",UIParent,"BasicFrameTemplate")
fParty[1]:SetSize(420,300)
fParty[1]:SetAlpha(.90)
fParty[1]:SetPoint("CENTER",0,0)
fParty[1]:SetMovable(true)
fParty[1]:EnableMouse(true)
fParty[1]:SetClampedToScreen(true)
fParty[1]:RegisterForDrag("RightButton")
fParty[1]:SetScript("OnDragStart", fParty[1].StartMoving)
fParty[1]:SetScript("OnDragStop", fParty[1].StopMovingOrSizing)

fParty[2] = CreateFrame("Button","fp2",fParty[1],"UIPanelButtonTemplate")
fParty[2]:SetSize(70,20)
fParty[2]:EnableMouse(true)
fParty[2]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then charStatBase[3] = "Tank"; if(charStatBase[5] == "Guild") then charStatBase[3] = charStatBase[3] .. " Guild"; end UpdateRoles(); end 
end)
fParty[2]:SetPoint("TOPLEFT",10,-50)
fParty[2]:SetText("Tank")
fParty[2]:SetNormalFontObject("GameFontNormal")

fParty[3] = CreateFrame("Button","fp3",fParty[1],"UIPanelButtonTemplate")
fParty[3]:SetSize(70,20)
fParty[3]:EnableMouse(true)
fParty[3]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then charStatBase[3] = "Healer"; if(charStatBase[5] == "Guild") then charStatBase[3] = charStatBase[3] .. " Guild"; end UpdateRoles(); end 
end)
fParty[3]:SetPoint("TOPLEFT",80,-50)
fParty[3]:SetText("Healer")
fParty[3]:SetNormalFontObject("GameFontNormal")

fParty[4] = CreateFrame("Button","fp4",fParty[1],"UIPanelButtonTemplate")
fParty[4]:SetSize(70,20)
fParty[4]:EnableMouse(true)
fParty[4]:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then charStatBase[3] = "Damage"; if(charStatBase[5] == "Guild") then charStatBase[3] = charStatBase[3] .. " Guild"; end UpdateRoles(); end 
end)
fParty[4]:SetPoint("TOPLEFT",150,-50)
fParty[4]:SetText("Damage")
fParty[4]:SetNormalFontObject("GameFontNormal")

fParty[5] = CreateFrame("Button","fp5",fParty[1],"UIPanelButtonTemplate")
fParty[5]:SetSize(70,20)
fParty[5]:EnableMouse(true)
fParty[5]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then UpdateRoles(); SendRole(); end 
end)
fParty[5]:SetPoint("TOPLEFT",220,-50)
fParty[5]:SetText("Ready")
fParty[5]:SetNormalFontObject("GameFontNormal")

fParty[7] = CreateFrame("ScrollFrame","fp7",fParty[1],"UIPanelScrollFrameTemplate")
fParty[6] = CreateFrame("Frame","fp6",fParty[7],"InsetFrameTemplate2")
fParty[6]:SetSize(400,1080)
fParty[6]:SetPoint("TOPLEFT",0,0)
fParty[7]:SetPoint("TOPLEFT",0,-90)
fParty[7]:SetSize(392,100)
fParty[7]:SetScrollChild(fParty[6])

fParty[8] = CreateFrame("Button","fp8",fParty[1],"UIPanelButtonTemplate")
fParty[8]:SetSize(140,20)
fParty[8]:EnableMouse(true)
fParty[8]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[5] = "GUILD"; UpdateRoles(); end 
end)
fParty[8]:SetPoint("TOPLEFT",10,-70)
fParty[8]:SetText("Guild")
fParty[8]:SetNormalFontObject("GameFontNormal")

fParty[9] = CreateFrame("Button","fp9",fParty[1],"UIPanelButtonTemplate")
fParty[9]:SetSize(140,20)
fParty[9]:EnableMouse(true)
fParty[9]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[5] = "YELL"; UpdateRoles(); end 
end)
fParty[9]:SetPoint("TOPLEFT",150,-70)
fParty[9]:SetText("Local")
fParty[9]:SetNormalFontObject("GameFontNormal")

for m=1,36 do
	local p = m + 9
	fParty[p] = CreateFrame("Button","fp" .. tostring(p),fParty[6],"UIPanelButtonTemplate")
	fParty[p]:SetSize(280,20)
	fParty[p]:EnableMouse(true)
	fParty[p]:SetNormalFontObject("GameFontNormal")
	fParty[p]:SetPoint("TOPLEFT",10,(-20 * m))
end
fParty[10]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Ragefire Chasm (Horde)"; UpdateRoles(); end 
end)
fParty[10]:SetText("Ragefire Chasm (H)")
fParty[11]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Wailing Caverns (15)"; UpdateRoles(); end 
end)
fParty[11]:SetText("Wailing Caverns (15)")
fParty[12]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "The Deadmines (18)"; UpdateRoles(); end 
end)
fParty[12]:SetText("The Deadmines (18)")
fParty[13]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "The Stockades (Alliance)"; UpdateRoles(); end 
end)
fParty[13]:SetText("The Stockades (A)")
fParty[14]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Shadowfang Keep (22)"; UpdateRoles(); end 
end)
fParty[14]:SetText("Shadowfang Keep (22)")
fParty[15]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Blackfathom Deeps (24)"; UpdateRoles(); end 
end)
fParty[15]:SetText("Blackfathom Deeps (24)")
fParty[16]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Gnomeregan (29)"; UpdateRoles(); end 
end)
fParty[16]:SetText("Gnomeregan (29)")
fParty[17]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "SM Graveyard (28)"; UpdateRoles(); end 
end)
fParty[17]:SetText("SM Graveyard (28)")
fParty[18]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "SM Library (29)"; UpdateRoles(); end 
end)
fParty[18]:SetText("SM Library (29)")
fParty[19]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "SM Armory (32)"; UpdateRoles(); end 
end)
fParty[19]:SetText("SM Armory (32)")
fParty[20]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Razorfen Kraul (30)"; UpdateRoles(); end 
end)
fParty[20]:SetText("Razorfen Kraul (30)")
fParty[21]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Razorfen Downs (40)"; UpdateRoles(); end 
end)
fParty[21]:SetText("Razorfen Downs (40)")
fParty[22]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "SM Cathedral (35)"; UpdateRoles(); end 
end)
fParty[22]:SetText("SM Cathedral (35)")
fParty[23]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Uldaman (42)"; UpdateRoles(); end 
end)
fParty[23]:SetText("Uldaman (42)")
fParty[24]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Zul'Farrak (44)"; UpdateRoles(); end 
end)
fParty[24]:SetText("Zul'Farrak (44)")
fParty[25]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Wicked Grotto (45)"; UpdateRoles(); end 
end)
fParty[25]:SetText("Wicked Grotto (45)")
fParty[26]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Foulspore Cavern (45)"; UpdateRoles(); end 
end)
fParty[26]:SetText("Foulspore Cavern (45)")
fParty[27]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Earthsong Falls (45)"; UpdateRoles(); end 
end)
fParty[27]:SetText("Earthsong Falls (45)")
fParty[28]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Atal'Hakkar (50)"; UpdateRoles(); end 
end)
fParty[28]:SetText("Atal'Hakkar (50)")
fParty[29]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Blackrock Depths (52)"; UpdateRoles(); end 
end)
fParty[29]:SetText("Blackrock Depths (52)")
fParty[30]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Lower Blackrock Spire (55)"; UpdateRoles(); end 
end)
fParty[30]:SetText("Lower Blackrock Spire (55)")
fParty[31]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Scholomance (58)"; UpdateRoles(); end 
end)
fParty[31]:SetText("Scholomance (58)")
fParty[32]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Stratholme Scarlet (55)"; UpdateRoles(); end 
end)
fParty[32]:SetText("Stratholme Scarlet (55)")
fParty[33]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Stratholme Scourge (58)"; UpdateRoles(); end 
end)
fParty[33]:SetText("Stratholme Scourge (58)")
fParty[34]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Dire Maul West (58)"; UpdateRoles(); end 
end)
fParty[34]:SetText("Dire Maul West (58)")
fParty[35]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Dire Maul North (58)"; UpdateRoles(); end 
end)
fParty[35]:SetText("Dire Maul North (58)")
fParty[36]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Dire Maul East (58)"; UpdateRoles(); end 
end)
fParty[36]:SetText("Dire Maul East (58)")
fParty[37]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Upper Blackrock Spire (60)"; UpdateRoles(); end 
end)
fParty[37]:SetText("Upper Blackrock Spire (60)")
fParty[38]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Onyxias Lair (60)"; UpdateRoles(); end 
end)
fParty[38]:SetText("Onyxias Lair (60)")
fParty[39]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "ZulGurub (60)"; UpdateRoles(); end 
end)
fParty[39]:SetText("Zul Gurub (60)")
fParty[40]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Molten Core (60)"; UpdateRoles(); end 
end)
fParty[40]:SetText("Molten Core (60)")
fParty[41]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Ruins of AhnQiraj (60)"; UpdateRoles(); end 
end)
fParty[41]:SetText("Ruins of Ahn Qiraj (60)")
fParty[42]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Blackwing Lair (60)"; UpdateRoles(); end 
end)
fParty[42]:SetText("Blackwing Lair (60)")
fParty[43]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Temple of AhnQiraj (60)"; UpdateRoles(); end 
end)
fParty[43]:SetText("Temple of Ahn Qiraj (60)")
fParty[44]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = "Naxxramas (60)"; UpdateRoles(); end 
end)
fParty[44]:SetText("Naxxramas (60)")
fParty[45]:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then charStatBase[4] = " Upper Naxxramas (60)"; UpdateRoles(); end 
end)
fParty[45]:SetText("Upper Naxxramas (60)")

fParty[46] = CreateFrame("ScrollFrame","fp45",fParty[1],"UIPanelScrollFrameTemplate")
fParty[47] = CreateFrame("Frame","fp46",fParty[45],"InsetFrameTemplate2")
fParty[46]:SetPoint("TOPLEFT",0,-190)
fParty[46]:SetSize(392,100)
fParty[46]:SetScrollChild(fParty[47])
fParty[47]:SetSize(400,1720)
fParty[47]:SetPoint("TOPLEFT",0,0)

for d=1,40 do
	local qr = d + 47
	fParty[qr] = CreateFrame("Button","fp" .. tostring(d),fParty[47],"UIPanelButtonTemplate")
	fParty[qr]:SetSize(300,100)
	fParty[qr]:EnableMouse(true)
	fParty[qr]:SetNormalFontObject("GameFontNormalLarge")
	fParty[qr]:SetPoint("TOPLEFT",10,(-10 + (d * -100)))
	if(d == 1) then fParty[qr]:SetPoint("TOPLEFT",10,-10) end
end

fParty[88] = fParty[1]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fParty[88]:SetSize(380,40)
fParty[88]:SetPoint("TOPLEFT", 10, -10)
fParty[88]:SetJustifyH("LEFT")

fDebuff[1] = CreateFrame("Frame","tbf",UIParent,"BasicFrameTemplate")
fDebuff[1]:SetSize(420,240)
fDebuff[1]:SetAlpha(.95)
fDebuff[1]:SetPoint("CENTER",0,0)
fDebuff[1]:SetMovable(true)
fDebuff[1]:EnableMouse(true)
fDebuff[1]:SetClampedToScreen(true)
fDebuff[1]:RegisterForDrag("RightButton")
fDebuff[1]:SetScript("OnDragStart", fDebuff[1].StartMoving)
fDebuff[1]:SetScript("OnDragStop", fDebuff[1].StopMovingOrSizing)

fDebuff[2] = CreateFrame("ScrollFrame","dbf",fDebuff[1],"UIPanelScrollFrameTemplate")
fDebuff[3] = CreateFrame("Frame","dbs",fDebuff[2],"InsetFrameTemplate2")
fDebuff[2]:SetSize(390,212)
fDebuff[2]:SetPoint("TOPLEFT",0,-22)
fDebuff[3]:SetPoint("TOPLEFT",0,0)
fDebuff[3]:SetSize(420,720)
fDebuff[2]:SetScrollChild(fDebuff[3])

fDebuff[4] = fDebuff[3]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fDebuff[4]:SetPoint("TOPLEFT", 10,-10)
fDebuff[4]:SetWidth(380)
fDebuff[4]:SetJustifyH("LEFT")

fDebuff[5] = fDebuff[3]:CreateFontString(nil,"OVERLAY","GameFontNormal")
fDebuff[5]:SetPoint("TOPLEFT", 10,-10)
fDebuff[5]:SetWidth(380)
fDebuff[5]:SetJustifyH("RIGHT")
fDebuff[5]:SetTextColor(1,1,1,1)

fSpells[1] = CreateFrame("Frame","tbs",UIParent,"BasicFrameTemplate")
fSpells[1]:SetSize(420,420)
fSpells[1]:SetAlpha(.95)
fSpells[1]:SetPoint("CENTER",0,0)
fSpells[1]:SetMovable(true)
fSpells[1]:EnableMouse(true)
fSpells[1]:SetClampedToScreen(true)
fSpells[1]:RegisterForDrag("RightButton")
fSpells[1]:SetScript("OnDragStart", fSpells[1].StartMoving)
fSpells[1]:SetScript("OnDragStop", fSpells[1].StopMovingOrSizing)

fGear[1]:Hide() ; fCombat[1]:Hide() ; fQuest[1]:Hide() ; fThreat[1]:Hide()
fOption[1]:Show() ; fRaid[1]:Hide() ; fOption[2]:Hide()
fDebuff[1]:Hide() ; fParty[1]:Hide() ; fSpells[1]:Hide()





